(****************************************************************************
*
*                       MegaGraph Graphics Library
*
*               Copyright (C) 1991-1997 SciTech Software, Inc.
*                            All rights reserved.
*
*  ======================================================================
*       This library is free software; you can use it and/or
*       modify it under the terms of the SciTech MGL Software License.
*
*       This library is distributed in the hope that it will be useful,
*       but WITHOUT ANY WARRANTY; without even the implied warranty of
*       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*       SciTech MGL Software License for more details.
*  ======================================================================
*
* Filename:     $Workfile:   MGLSPR.PAS  $
* Version:      $Revision:   1.0  $
*
* Language:     TMT Pascal Multitarget 3
* Environment:  Win32
* C Headers:    sprite.h
*
* Description:  Game Framework Sprite Manager for SciTech MGL. This library
*               provides a simple yet powerful bitmap sprite manager for
*               automatically managing both software and hardware sprites
*               within the MGL and Game Framework. The sprite manager
*               is completely stand-alone and can be used independantly of
*               the main Game Framework functions.
*
* $Date:  03 Oct 1997 $ $Author of original C/C++ code:  KendallB  $
* $Date:  10 Apr 1998 $ $Author of TMT Pascal version :  Vadim Bodrov  $
*
****************************************************************************)

unit MGLSpr;

interface

uses
    Windows,MGLTypes,MGLFx;

{$OA-}
{$W-}

{== Function prototypes ====================================================}

type
    PSPR_Bitmap = Pointer;

function    SPR_mgrInit conv arg_cdecl (dc: PMGLDC; useRLE: LongBool): Boolean;
procedure   SPR_mgrExit conv arg_cdecl;
procedure   SPR_mgrEmpty conv arg_cdecl;
procedure   SPR_mgrReloadHW conv arg_cdecl;
function    SPR_mgrUsingOffscreenDC conv arg_cdecl : LongBool;
function    SPR_mgrOffscreenCacheFull conv arg_cdecl : LongBool;
function    SPR_mgrAddOpaqueBitmap conv arg_cdecl (bmp: pbitmap_t): PSPR_bitmap;
function    SPR_mgrAddTransparentBitmap conv arg_cdecl (bmp: pbitmap_t; transparent: color_t): PSPR_bitmap;
procedure   SPR_draw conv arg_cdecl (bmp: PSPR_bitmap; x, y: int);

{===========================================================================}

implementation

const
    DLLName = 'MGLGM.DLL';

function    SPR_mgrInit conv arg_cdecl (dc: PMGLDC; useRLE: LongBool): Boolean;  external DLLName name '_SPR_mgrInit';
procedure   SPR_mgrExit conv arg_cdecl;  external DLLName name '_SPR_mgrExit';
procedure   SPR_mgrEmpty conv arg_cdecl;  external DLLName name '_SPR_mgrEmpty';
procedure   SPR_mgrReloadHW conv arg_cdecl;  external DLLName name '_SPR_mgrReloadHW';
function    SPR_mgrUsingOffscreenDC conv arg_cdecl : LongBool;  external DLLName name '_SPR_mgrUsingOffscreenDC';
function    SPR_mgrOffscreenCacheFull conv arg_cdecl : LongBool;  external DLLName name '_SPR_mgrOffscreenCacheFull';
function    SPR_mgrAddOpaqueBitmap conv arg_cdecl (bmp: pbitmap_t): PSPR_bitmap;  external DLLName name '_SPR_mgrAddOpaqueBitmap';
function    SPR_mgrAddTransparentBitmap conv arg_cdecl (bmp: pbitmap_t; transparent: color_t): PSPR_bitmap;  external DLLName name '_SPR_mgrAddTransparentBitmap';
procedure   SPR_draw conv arg_cdecl (bmp: PSPR_bitmap; x, y: int);  external DLLName name '_SPR_draw';

end.
