(***********************************************)
(*                                             *)
(* Demo Program for ZTimer Unit                *)
(* Copyright (c) 1997 by TMT Development Corp. *)
(* Author: Vadim Bodrov, TMT Development Corp. *)
(*                                             *)
(* Targets:                                    *)
(*   MS-DOS 32-bit protected mode              *)
(*   WIN32 console application                 *)
(*                                             *)
(***********************************************)
{$r-}
program ZTest;

uses ZTimer, CRT;

const
 CpuTypes: array [0..6] of string[20] =
 (
  'Unknown',
  'Intel 80386',
  'Intel 80486',
  'Intel Pentium(R)',
  'Intel PentiumPro(R)',
  'Intel PentiumII(R)',
  'Unknown Pentium'
 );

var
  Key:    Char;
  isTimerOn: Boolean:= TRUE;

function ZeroFill(n: Real): String;
var
  i: Dword;
  s: String;
begin
  str(n:10:2,s);
  Result := '';
  for i := 1 to Length(s) do
    if s[i] = ' ' then
      Result := Result + '0'
    else
      Result := Result + s[i];
end;

begin
  ULZTimerOn;

  ClrScr;
  HideCursor;
  Writeln('Zen Timer test program');
  Writeln('Copyright (c) 1998 TMT Development Corporation');
  Writeln;

  Writeln('CPU type          : ', CPUTypes[CPU_getProcessorType]);
  Writeln('CPU speed         : ', CPU_getProcessorSpeed,' Mhz');

  Write('MMX technology    : ');
  if CPU_haveMMX then
    Writeln('Supported')
  else
    Writeln('Not supported');

  ULZTimerOn;

  GotoXY(1, 13);
  Writeln('Press "Esc" to quit this test');
  repeat
   if Keypressed then
     Key := ReadKey
   else
     Key := Char(0);
   GotoXY(1, 10);
   Writeln('ULZ Timer         : ', ZeroFill(ULZTimerLap*ULZTimerResolution),
    '   - press "Enter" to reset the timer');

   if Key=#13 then begin
    isTimerOn := not isTimerOn;
    if isTimerOn then
      ULZTimerOn
    else
      ULZTimerOff;
   end;
  until Key = #27;

  ShowCursor;

  ULZTimerOff;

  Writeln;
  Writeln('Test performing time: ', Round(ULZTimerCount * ULZTimerResolution), ' secs.');
end.
